#Compiler PBWin 10
#Compile Exe
#Dim All
#Option Version5
#Include "Win32API.inc"
#Include "richedit.inc"
#Include "CommCtrl.inc"
#Resource Icon, aaa, "images\mail.ico"
#Resource Icon, bbb, "images\help.ico"

Type EmailType
    folder As String * 50
    from As String * 50
    to As String * 50
    date As String * 20
    subject As String * 200
End Type

Type CustomColors
   c(15) As Long
End Type

$Ver = "gbForumMail  v1.03"
%FR_Up = 0

%IDC_Splitter  = 500
%IDC_StatusBar = 501
%IDC_ListView  = 502
%IDC_RichEdit  = 503
%IDC_Label     = 504
%IDC_HelpX     = 505

%IDC_Find       = 602
%IDC_ComboTerms = 604
%IDC_Up         = 605
%IDC_Down       = 606
%IDC_MatchCase  = 607
%IDC_SearchAll  = 608
%IDC_ComboFolders = 609

%IDM_CutRE       = 700
%IDM_CopyRE      = 701
%IDM_PasteRE     = 702
%IDM_DeleteRE    = 703
%IDM_Sep         = 704
%IDM_SelectAllRE = 705
%IDM_CopyAllRE   = 706
%IDM_Search      = 707
%IDM_ShowHeaders = 708
%IDM_CutCB       = 709
%IDM_CopyCB      = 710
%IDM_PasteCB     = 711
%IDM_DeleteCB    = 712
%IDM_ClearTerms  = 713
%IDM_SelectAppFont = 714
%IDM_ReSetAppFont = 715
%IDM_QuoteColor  = 716
%IDM_CodeColor   = 717
%IDM_ResetColors = 718
%IDM_EnsureVisible = 719

%IDM_Summary           = 800
%IDM_AlternatingColors = 801
%IDM_SyntaxHighlighting= 802

' Global Variables: handles =============================================================
Global hDlg,hContextRE,hContextLV,hContextCB,hRichEdit,hHook,hComboEdit As Dword
Global hFontDefault,hFontRE,ghHook As Dword
Global EmailContent(), SearchTerm, CurrentFolder, FontName As String
Global SortDirection, SplitVInWork, VBarTop, CS, OldTBProc, OldCBProc, AlternatingColors, SyntaxHighlighting  As Long
Global EMailHeader() As EmailType, MatchCase, SearchAll, SearchUp, ShowHeader, FontSize, FontStyle As Long
Global QuoteColor, CodeColor As Long, CustomColorList As CustomColors

' Main Function =======================================================================
Function PBMain()
    Local style&
    style& = %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoVScroll _
            Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn Or %WS_VScroll Or %WS_ClipSiblings
    Font New "Tahoma", 10, 0 To hFontDefault
    Dialog New Pixels, 0, $Ver + ":  vBulletin Private Mail Viewer",300,300,600,600, %WS_OverlappedWindow Or %WS_ClipChildren, 0 To hDlg
    Dialog Set Icon hDlg, "aaa"

    Control Add ComboBox, hDlg, %IDC_ComboFolders, , 10,20,140,100, %CBS_DropDownList Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
    ComboBox Add hDlg, %IDC_ComboFolders, "All Email Folders"

    Control Add Label, hDlg, %IDC_Label, "Search Term:", 165,23,80,20
    Control Add ComboBox, hDlg, %IDC_ComboTerms, , 235,20,150,150, %CBS_DropDown Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
    Control Add Button, hDlg, %IDC_Find, "Find",400,20,40,20

    Control Add Option, hDlg, %IDC_Up, "Up",460,12,50,20, %WS_Group Or %WS_TabStop
    Control Add Option, hDlg, %IDC_Down, "Down", 460,30,50,20
    Control Add CheckBox, hDlg, %IDC_MatchCase, "Match Case", 520,12,100,20, %WS_Group Or %WS_TabStop
    Control Add CheckBox, hDlg, %IDC_SearchAll, "Search All", 520,30,100,20, %WS_Group Or %WS_TabStop

    Control Add ImgButton, hDlg, %IDC_HelpX, "bbb", 620,15,30,30

    Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
    Control Add ListView, hDlg, %IDC_ListView,"Email", 10,50,380,220, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel
    ListView Insert Column hDlg, %IDC_ListView, 1, "Box", 85, 0
    ListView Insert Column hDlg, %IDC_ListView, 2, "From", 140, 0
    ListView Insert Column hDlg, %IDC_ListView, 3, "To", 140, 0
    ListView Insert Column hDlg, %IDC_ListView, 4, "Date", 130, 0
    ListView Insert Column hDlg, %IDC_ListView, 5, "Subject", 500, 0
    ListView Insert Column hDlg, %IDC_ListView, 6, "Index", 0, 0     '<----- array position of email
    ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
    ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_FullRowSelect
    Control Set Font hDlg, %IDC_ListView, hFontDefault

    CreateRichEditControl
    Control Add Label, hDlg, %IDC_Splitter, "",  0,300, 410, 6, %SS_Notify , %WS_Ex_ClientEdge   ' left/right - does vertical split
    Control Set Color hDlg, %IDC_Splitter, %rgb_Coral, %rgb_Coral
    Dialog Show Modal hDlg Call DlgProc()
End Function

'monitor mouse movement=================================
CallBack Function DlgProc() As Long
   Local x,y,w,h,iSelect,iReturn As Long, temp$, LVData As NM_ListView
   Local lplvcd As NMLVCUSTOMDRAW Ptr
   Select Case Cb.Msg
       Case %WM_InitDialog
           SubClassControls
           BuildAcceleratorTable
           CreateContextMenu
           Settings_INI "get"
           CreateAppFont

           ComboBox Select hDlg, %IDC_ComboTerms, 1
           Dialog Get Client hDlg To w,h
           Menu Set State hContextRE,  ByCmd %IDM_ShowHeaders, ShowHeader * 8
           Menu Set State hContextLV,  ByCmd %IDM_AlternatingColors, AlternatingColors * 8
           Menu Set State hContextRE,  ByCmd %IDM_SyntaxHighlighting, SyntaxHighlighting * 8
           Control Set Loc hDlg, %IDC_Splitter,0,h-VBarTop
           Control Set Text hDlg, %IDC_ComboTerms, SearchTerm
           Control Set Check hDlg, %IDC_MatchCase, MatchCase
           Control Set Check hDlg, %IDC_SearchAll, SearchAll
           Control Set Option hDlg, IIf(SearchUp,%IDC_Up,%IDC_Down), %IDC_Up, %IDC_Down
           ReadAllFiles
           ComboBox Find Exact hDlg, %IDC_ComboFolders, 1, CurrentFolder To iReturn  'already in combofolder?
           ComboBox Select hDlg, %IDC_ComboFolders, IIf(iReturn,iReturn,1)
           LoadListView
           SetREText CS
           ListView Select hDlg, %IDC_ListView, CS
           Control Set Focus hDlg, %IDC_Listview
           Control Send hDlg, %IDC_ListView, %LVM_EnsureVisible, CS-1, %True

       Case %WM_Command
           Select Case Cb.Ctl
               Case %IDM_EnsureVisible
                   ListView Get Select hDlg, %IDC_ListView To iSelect
                   Control Send hDlg, %IDC_ListView, %LVM_EnsureVisible, iSelect-1, %True
               Case %IDC_ComboFolders
                   If Cb.CtlMsg = %CBN_SelChange Then
                       LoadListView
                       SetREText 1
                       Control Send hDlg, %IDC_ListView, %LVM_EnsureVisible, CS-1, %True
                       ListView Select hDlg, %IDC_ListView, 1
                       Control Set Focus hDlg, %IDC_Listview
                   End If
               Case %IDM_CutRE        : Control Send hDlg, %IDC_RichEdit, %WM_CUT, 0, 0
               Case %IDM_CopyRE       : Control Send hDlg, %IDC_RichEdit, %WM_COPY, 0, 0
               Case %IDM_PasteRE      : Control Send hDlg, %IDC_RichEdit, %WM_PASTE, 0, 0
               Case %IDM_DeleteRE     : Control Send hDlg, %IDC_RichEdit, %WM_CLEAR, 0, 0
               Case %IDM_SelectAllRe  : Control Send hDlg, %IDC_RichEdit, %EM_SetSel, 0, -1
               Case %IDM_CopyAllRE
                   Control Get Text hDlg, %IDC_RichEdit To temp$
                   Clipboard Reset
                   Clipboard Set Text temp$
               Case %IDM_ShowHeaders
                   ShowHeader = ShowHeader Xor 1
                   Menu Set State hContextRE,  ByCmd %IDM_ShowHeaders, ShowHeader * 8
                   ListView Get Select hDlg, %IDC_ListView To iSelect
                   SetREText iSelect
               Case %IDM_CutCB        : SendMessage hComboEdit, %WM_CUT, 0, 0
               Case %IDM_CopyCB       : SendMessage hComboEdit, %WM_COPY, 0, 0
               Case %IDM_PasteCB      : SendMessage hComboEdit, %WM_PASTE, 0, 0
               Case %IDM_DeleteCB     : SendMessage hComboEdit, %WM_CLEAR, 0, 0
               Case %IDM_ClearTerms
                   ComboBox Reset hDlg, %IDC_ComboTerms
               Case %IDC_Find
                   While FindSearchTerm : Wend
               Case %IDM_Search   : Control Set Focus hDlg, %IDC_ComboTerms   'accelerator table
               Case %IDC_HelpX
                   temp$ = "http://www.garybeene.com/sw/gbforummail.htm"
                   iReturn = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
               Case %IdOk
                   While FindSearchTerm : Wend
                   SendMessage hComboEdit, %EM_SetSel, 0, -1
               Case %IDM_Summary
                   ListView Get Count hDlg, %IDC_ListView To iReturn
                   MsgBoxX "Total Emails: " + Str$(iReturn), %MB_Ok + %MB_IconInformation, "Email Summary"
               Case %IDM_SyntaxHighlighting
                   SyntaxHighlighting = SyntaxHighlighting Xor 1
                   Menu Set State hContextRE, ByCmd %IDM_SyntaxHighlighting, SyntaxHighlighting * 8
                   ListView Get Select hDlg, %IDC_ListView To iSelect
                   SetREText iSelect
               Case %IDM_AlternatingColors
                   AlternatingColors = AlternatingColors Xor 1
                   Menu Set State hContextLV,  ByCmd %IDM_AlternatingColors, AlternatingColors * 8
                   Control ReDraw hDlg, %IDC_ListView
               Case %IDM_SelectAppFont  :  SelectAppFont
               Case %IDM_ResetAppFont
                   Control Set Font hDlg, %IDC_RichEdit, hFontDefault
                   FontName = "Tahoma" : FontSize = 10 : FontStyle = 0
               Case %IDM_CodeColor
                   CodeColor = SelectColor(CodeColor)
                   ListView Get Select hDlg, %IDC_ListView To iSelect
                   SetREText iSelect
               Case %IDM_QuoteColor
                   QuoteColor = SelectColor(QuoteColor)
                   ListView Get Select hDlg, %IDC_ListView To iSelect
                   SetREText iSelect
               Case %IDM_ResetColors
                   QuoteColor = %rgb_DarkGreen
                   CodeColor = %Blue
                   ListView Get Select hDlg, %IDC_ListView To iSelect
                   SetREText iSelect
           End Select
       Case %WM_Destroy
           Control Get Check hDlg, %IDC_MatchCase To MatchCase
           Control Get Check hDlg, %IDC_SearchAll To SearchAll
           Control Get Check hDlg, %IDC_Up To SearchUp
           Control Get Text hDlg, %IDC_ComboTerms To SearchTerm
           ListView Get Select hDlg, %IDC_ListView To CS
           ComboBox Get Text hDlg, %IDC_ComboFolders To CurrentFolder
           Settings_INI "save"
           SetWindowLong hRichEdit, %GWL_WNDPROC, OldTBProc   'un-subclass
           SetWindowLong hComboEdit, %GWL_WNDPROC, OldCBProc   'un-subclass
       Case %WM_ContextMenu
           If GetFocus = GetDlgItem(hDlg, %IDC_ListView) Then
             x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
             TrackPopupMenu hContextLV, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
             Function = 0 : Exit Function
           End If
      Case %WM_Size
         ResizeWindow
      Case %WM_Notify
          Select Case Cb.NmId
              Case %IDC_RichEdit
                  If Cb.NmCode = %EN_Link Then RichEditHyperLink(hDlg,Cb.LParam)
              Case %IDC_ListView
                  Select Case Cb.NmCode
                     Case %LVN_ItemChanged  '%NM_Click
                        ListView Get Select hDlg, %IDC_ListView To iSelect
                        SetREText iSelect
                     Case %LVN_ColumnClick
                        Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                        ListView Get Select hDlg, %IDC_ListView To iSelect
                        ListView Get Text hDlg, %IDC_ListView, iSelect, 6 To temp$
                        iSelect = Val(temp$)        '<---- array index of selection
                        SortDirection = SortDirection Xor 1
                        MousePtr 11

                        Local iEventMask&
                        iEventMask& = SendMessage(hRichEdit, %EM_GETEVENTMASK, 0, 0)   'save event mask
                        SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, 0)                 'disable event mask
                        SendMessage(hRichEdit, %WM_SETREDRAW, 0, 0)                    'disable redraw
                        'Sort
                        If SortDirection Then
                           ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Ascend
                        Else
                           ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Descend
                        End If
                        'ensure selected row stays visible
                        ListView Get Count hDlg, %IDC_ListView To iReturn
                        For x = 1 To iReturn
                            ListView Get Text hDlg, %IDC_ListView, x, 6 To temp$
                            If Val(temp$) = iSelect Then
                                Control Send hDlg, %IDC_ListView, %LVM_EnsureVisible, x-1, %True
                                Exit For
                            End If
                        Next i
                       'restore eventmask, enable eventmask/redraw
                       SendMessage hRichEdit, %WM_SETREDRAW, 1, 0                         'turn on redraw
                       InvalidateRect hRichEdit, ByVal %NULL, 0 : UpdateWindow hRichEdit  'refresh
                       SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, iEventMask&)           'enable event mask


                        MousePtr 1
                     Case %NM_CustomDraw
                         If AlternatingColors Then
                             lplvcd = Cb.LParam
                             Select Case @lplvcd.nmcd.dwDrawStage
                                 Case %CDDS_PrePaint
                                     Function = %CDRF_NOTIFYITEMDRAW : Exit Function
                                 Case %CDDS_ItemPrePaint
                                     Select Case @lplvcd.nmcd.dwItemSpec Mod 6
                                         Case 3,4,5
                                             @lplvcd.clrTextBk = RGB(235,235,235) 'item BG color
                                     End Select
                                     Function = %CDRF_NEWFONT : Exit Function   'change item/subitem BG colors
                             End Select
                         End If
                  End Select
         End Select
      Case %WM_SetCursor
            iReturn = GetDlgCtrlID (Cb.WParam)
            If iReturn = %IDC_Splitter Then MousePtr 7 : Function = 1    '7 = vertical cursor
            Select Case Hi(Word, Cb.LParam)
               Case %WM_LButtonDown
                  If iReturn = %IDC_Splitter Then SplitVInWork = 1  'sets flags to say splitter action has started (no actual movement yet)
               Case %WM_MouseMove
                  If SplitVInWork Then If MoveBarUpDown Then ResizeWindow  'Repositions splitter bars to match mouse position (if position has changed)
               Case %WM_LButtonUp
                  SplitVInWork = 0  'sets flags to say splitter action has ended
            End Select
   End Select
End Function

Function MoveBarUpDown As Long
    Local pt As Point, h As Long, w As Long
    Static oldY As Long
    Dialog Get Client hDlg To w,h
    GetCursorPos pt               'pt has xy screen coordinates
    ScreenToClient hDlg, pt       'pt now has client coordinates
    If pt.y <> oldY Then
        VBarTop = h - (Pt.y-3)        'actually, should only do one or the other
        Control Set Loc hDlg,  %IDC_Splitter, 5, h-VBarTop
        oldY = pt.y
        Function = %True
    End If
End Function

Sub ResizeWindow
   Local vx,vy,w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_Splitter, w, 6
   Control Get Loc hDlg, %IDC_Splitter To vx, vy
   Control Set Size hDlg, %IDC_ListView, w - 20, vy - 55
   Control Set Loc  hDlg, %IDC_RichEdit, 5, vy + 8
   Control Set Size hDlg, %IDC_RichEdit, w - 20, h - vy - 35
   Dialog ReDraw hDlg
End Sub

Sub ReadAllFiles
    Local msg$, temp$, folder$, fName$, i, iPos, EmailCount As Long

    If IsFolder (Exe.Path$ + "messages") = %False Then MkDir Exe.Path$ + "messages"

    ReDim EmailHeader(0), EmailContent(0)
    fName$ = Dir$(Exe.Path$ + "messages\*.txt")
    While Len(fName$)
        Open Exe.Path$+"messages\" + fName$ For Input As #1
        For i = 1 To 5 : Line Input #1, temp$ : Next i
        Replace $Tab With " " In temp$
        folder$ = Trim$(Mid$(temp$,9))

        ComboBox Find Exact hDlg, %IDC_ComboFolders, 1, folder$ To i  'already in combofolder?
        If i=0 Then ComboBox Add hDlg, %IDC_ComboFolders, folder$     'put in combofolder if not already there

        Line Input #1, temp$ : Line Input #1, temp$
        While IsFalse(Eof(1))
            Line Input #1, temp$
            If Left$(temp$,20) = String$(20,"=") Then
                Incr EmailCount
                ReDim Preserve EmailContent(EmailCount), EmailHeader(EmailCount)
                msg$ = ""
                EmailHeader(EmailCount).Folder = folder$
                Line Input #1, temp$ : Replace $Tab With $Spc In temp$
                EmailHeader(EmailCount).From = Trim$(Mid$(temp$,7))
                Line Input #1, temp$ : Replace $Tab With $Spc In temp$
                EmailHeader(EmailCount).To = Trim$(Mid$(temp$,5))
                Line Input #1, temp$ : Replace $Tab With $Spc In temp$
                EmailHeader(EmailCount).date = Trim$(Mid$(temp$,7))
                Line Input #1, temp$ : Replace $Tab With $Spc In temp$
                EmailHeader(EmailCount).subject = Trim$(Mid$(temp$,8))
                Line Input #1, temp$
            Else
                msg$ = msg$ + $CrLf + Trim$(temp$)
                EmailContent(EmailCount) = Mid$(msg$,3)     'get rid of leading $crlf
            End If
        Wend
        Close #1
        fName$ = Dir$
    Wend

    For i = 0 To EmailCount
        Do : RegRepl "\s\[quote=.*\]" In EmailContent(i) With "\[quote\]" At iPos To iPos, EmailContent(i) : Loop While iPos
        Do : RegRepl "\s\[url=.*\]" In EmailContent(i) With "\[url\]" At iPos To iPos, EmailContent(i) : Loop While iPos
        Do : RegRepl "\s\[/*email\]" In EmailContent(i) With $Spc At iPos To iPos, EmailContent(i) : Loop While iPos
        Do : RegRepl "\s\[/*url\]"   In EmailContent(i) With $Spc At iPos To iPos, EmailContent(i) : Loop While iPos
        Do : RegRepl "\s\[/*img\]"   In EmailContent(i) With $Spc At iPos To iPos, EmailContent(i) : Loop While iPos
        Do : RegRepl "\s\[/*b\]"   In EmailContent(i) With $Spc At iPos To iPos, EmailContent(i) : Loop While iPos
        Do : RegRepl "\s\[/*i\]"   In EmailContent(i) With $Spc At iPos To iPos, EmailContent(i) : Loop While iPos
        'Replace "[EMAIL]" With $Spc In EMailContent(i)
        'Replace "[/EMAIL]" With $Spc In EMailContent(i)
        'Replace "[URL]" With $Spc In EMailContent(i)
        'Replace "[/URL]" With $Spc In EMailContent(i)
        'Replace "[IMG]" With $Spc In EMailContent(i)
        'Replace "[/IMG]" With $Spc In EMailContent(i)
        'Replace "[url]" With $Spc In EMailContent(i)
        'Replace "[/url]" With $Spc In EMailContent(i)
        'Replace "[img]" With $Spc In EMailContent(i)
        'Replace "[/img]" With $Spc In EMailContent(i)
        'Replace "[email]" With $Spc In EMailContent(i)
        'Replace "[/email]" With $Spc In EMailContent(i)
    Next i
End Sub

Sub Settings_INI(Task$)
   Local i,x,y As Long, xResult, yResult, tempz, INIFileName As AsciiZ * %Max_Path, temp$
   'set ini filename
   INIFileName = Exe.Path$ + "gbforummail.ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "670", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "600", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height
      'get value for string variables
      GetPrivateProfileString "All", "FontName", "Tahoma", tempz, %Max_Path, INIFileName
      FontName = tempz
      GetPrivateProfileString "All", "CurrentFolder", "All Email Folders", tempz, %Max_Path, INIFileName
      CurrentFolder = tempz
      GetPrivateProfileString "All", "SearchTerm", "API", tempz, %Max_Path, INIFileName
      SearchTerm = tempz

      For i = 1 To 10
          GetPrivateProfileString "All", "SearchTerm" + Trim$(Str$(i)), "", tempz, %Max_Path, INIFileName
          temp$ = tempz
          If Len(temp$) Then
              ComboBox Insert hDlg, %IDC_ComboTerms, i, temp$
          Else
              If i = 1 Then ComboBox Insert hDlg, %IDC_ComboTerms, i, "API"
              If i = 2 Then ComboBox Insert hDlg, %IDC_ComboTerms, i, "SDK"
              If i = 3 Then ComboBox Insert hDlg, %IDC_ComboTerms, i, "Debug"
              If i = 4 Then ComboBox Insert hDlg, %IDC_ComboTerms, i, "Error"
              If i = 5 Then ComboBox Insert hDlg, %IDC_ComboTerms, i, "Graphic"
          End If
      Next i

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", tempz, %Max_Path, INIFileName
      FontSize = Val(tempz)
      Getprivateprofilestring "All", "FontStyle", "0", tempz, %Max_Path, INIFileName
      FontStyle = Val(tempz)
      Getprivateprofilestring "All", "VBarTop", "300", tempz, %Max_Path, INIFileName
      VBarTop = Val(tempz)
      Getprivateprofilestring "All", "CS", "1", tempz, %Max_Path, INIFileName
      CS = Val(tempz)
      Getprivateprofilestring "All", "MatchCase", "0", tempz, %Max_Path, INIFileName
      MatchCase = Val(tempz)
      Getprivateprofilestring "All", "SearchAll", "0", tempz, %Max_Path, INIFileName
      SearchAll = Val(tempz)
      Getprivateprofilestring "All", "SearchUp", "0", tempz, %Max_Path, INIFileName
      SearchUp = Val(tempz)
      Getprivateprofilestring "All", "ShowHeader", "1", tempz, %Max_Path, INIFileName
      ShowHeader = Val(tempz)
      Getprivateprofilestring "All", "AlternatingColors", "1", tempz, %Max_Path, INIFileName
      AlternatingColors = Val(tempz)
      Getprivateprofilestring "All", "ColorQuotes", "1", tempz, %Max_Path, INIFileName
      SyntaxHighlighting = Val(tempz)
      Getprivateprofilestring "All", "CodeColor", Str$(%Blue), tempz, %Max_Path, INIFileName
      CodeColor = Val(tempz)
      Getprivateprofilestring "All", "QuoteColor", Str$(%rgb_DarkGreen), tempz, %Max_Path, INIFileName
      QuoteColor = Val(tempz)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i

   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      Dialog Get Client hDlg To x,y
      'save string variables
      WritePrivateProfileString "All", "FontName", (FontName), INIFileName
      WritePrivateProfileString "All", "CurrentFolder", (CurrentFolder), INIFileName
      WritePrivateProfileString "All", "SearchTerm", (SearchTerm), INIFileName
      For i = 1 To 10
          ComboBox Get Text hDlg, %IDC_ComboTerms, i To temp$
          WritePrivateProfileString "All", "SearchTerm" + Trim$(Str$(i)),(temp$), INIFileName
      Next i
     'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontStyle", (Str$(FontStyle)), INIFileName
      WritePrivateProfileString "All", "VBarTop", (Str$(VBarTop)), INIFileName
      WritePrivateProfileString "All", "CS", (Str$(CS)), INIFileName
      WritePrivateProfileString "All", "MatchCase", (Str$(MatchCase)), INIFileName
      WritePrivateProfileString "All", "SearchAll", (Str$(SearchAll)), INIFileName
      WritePrivateProfileString "All", "SearchUp", (Str$(SearchUp)), INIFileName
      WritePrivateProfileString "All", "ShowHeader", (Str$(ShowHeader)), INIFileName
      WritePrivateProfileString "All", "AlternatingColors", (Str$(AlternatingColors)), INIFileName
      WritePrivateProfileString "All", "ColorQuotes", (Str$(SyntaxHighlighting)), INIFileName
      WritePrivateProfileString "All", "CodeColor", (Str$(CodeColor)), INIFileName
      WritePrivateProfileString "All", "QuoteColor", (Str$(QuoteColor)), INIFileName

      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i

   End If
End Sub

Sub CreateContextMenu
   Menu New PopUp To hContextLV
   Menu Add String, hContextLV, "Show Email Summary",  %IDM_Summary,  %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
'   Menu Add String, hContextLV, "Select App Font",  %IDM_SelectAppFont,  %MF_Enabled
'   Menu Add String, hContextLV, "Reset App Font",  %IDM_ResetAppFont,  %MF_Enabled
'   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Alternating Line Colors",  %IDM_AlternatingColors,  %MF_Enabled

   Menu New PopUp To hContextCB
   Menu Add String, hContextCB, "Cut",  %IDM_CutCB,  %MF_Enabled
   Menu Add String, hContextCB, "Copy",  %IDM_CopyCB,  %MF_Enabled
   Menu Add String, hContextCB, "Paste",  %IDM_PasteCB,  %MF_Enabled
   Menu Add String, hContextCB, "Delete", %IDM_DeleteCB,  %MF_Enabled
   Menu Add String, hContextCB, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextCB, "Clear Search Terms", %IDM_ClearTerms,  %MF_Enabled

   Menu New PopUp To hContextRE
'   Menu Add String, hContextRE, "Cut",  %IDM_CutRE,  %MF_Enabled
   Menu Add String, hContextRE, "Copy Selection",  %IDM_CopyRE,  %MF_Enabled
'   Menu Add String, hContextRE, "Paste",  %IDM_PasteRE,  %MF_Enabled
'   Menu Add String, hContextRE, "Delete", %IDM_DeleteRE,  %MF_Enabled
'   Menu Add String, hContextRE, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextRE, "Select All", %IDM_SelectAllRE,  %MF_Enabled
   Menu Add String, hContextRE, "Copy All", %IDM_CopyAllRE,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextRE, "Select Font",  %IDM_SelectAppFont,  %MF_Enabled
   Menu Add String, hContextRE, "Reset Font",  %IDM_ResetAppFont,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextRE, "Select Code Color",  %IDM_CodeColor,  %MF_Enabled
   Menu Add String, hContextRE, "Select Quote Color",  %IDM_QuoteColor,  %MF_Enabled
   Menu Add String, hContextRE, "Reset Colors",  %IDM_ResetColors,  %MF_Enabled
   Menu Add String, hContextRE, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextRE, "Show Headers", %IDM_ShowHeaders,  %MF_Enabled
   Menu Add String, hContextRE, "Highlight Quotes/Code", %IDM_SyntaxHighlighting,  %MF_Enabled
End Sub

Function NewTBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextRE, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldTBProc, hWnd, Msg, wParam, lParam)
End Function

Function NewCBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextCB, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldCBProc, hWnd, Msg, wParam, lParam)
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(3)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDC_HelpX             : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDM_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDM_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E      : ac(c).cmd   = %IDM_EnsureVisible     : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function


Sub SetREText(iPos As Long)
   Local temp$

   'get true iPos
   ListView Get Text hDlg, %IDC_ListView, iPos, 6 To temp$
   iPos = Val(temp$)

   If ShowHeader Then
       temp$ = "From: " + Trim$(EmailHeader(iPos).from)
       temp$ = temp$ + $CrLf + "To: " + Trim$(EmailHeader(iPos).to)
       temp$ = temp$ + $CrLf + "Date: " + Trim$(EmailHeader(iPos).date)
       temp$ = temp$ + $CrLf + "Subject: " + Trim$(EmailHeader(iPos).subject)
       temp$ = temp$ + $CrLf + $CrLf + EmailContent(iPos)
       Control Set Text hDlg, %IDC_RichEdit, temp$
   Else
       Control Set Text hDlg, %IDC_RichEdit, EmailContent(iPos)
   End If
   If SyntaxHighlighting Then ApplySyntaxHighlighting
   Control Send hDlg, %IDC_RichEdit, %EM_SetSel, 0, 0
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, Trim$(EmailHeader(iPos).subject)
End Sub

Sub CreateRichEditControl
   Local style&
'   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
'             Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %WS_ClipChildren Or %ES_NoHideSel
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoVScroll _
            Or %ES_WantReturn Or %WS_TabStop Or %WS_ClipChildren Or %ES_NoHideSel
   LoadLibrary("riched20.dll") : InitCommonControls
   Control Add "RichEdit20A", hDlg, %IDC_RichEdit, "",0,50,200,200, style&, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_RichEdit To hRichEdit
   Control Send hDlg, %IDC_RichEdit, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE Or %ENM_CHANGE Or %ENM_LINK
   Control Send hDlg, %IDC_RichEdit, %EM_SETLIMITTEXT, &H100000&, 0
'   Control Send hDlg, %IDC_RichEdit, %EM_SetTextMode, %TM_PlainText, 0
'   Control Send hDlg, %IDC_RichEdit, %EM_SetMargins, %EC_LeftMargin, 70
   Control Send hDlg, %IDC_RichEdit, %EM_AutoURLDetect, %True, 0
   Control Send hDlg, %IDC_RichEdit, %EM_SetReadOnly, %True, 0
End Sub

Function FindSearchTerm() As Long
      Local lRes,iCount,iSelect As Long, ft As FINDTEXTEX

      'update search paramenters
      Control Get Text hDlg,  %IDC_ComboTerms To SearchTerm : If SearchTerm = "" Then Beep : SetBeepMsg "No search term!" : Exit Function
      Control Get Check hDlg, %IDC_MatchCase  To MatchCase
      Control Get Check hDlg, %IDC_Up         To SearchUp
      Control Get Check hDlg, %IDC_SearchAll  To SearchAll

      'always put most recent search term at top. if existsadd search term, if new
      ComboBox Find Exact hDlg, %IDC_ComboTerms, 1, SearchTerm To lRes
      If lRes Then ComboBox Delete hDlg, %IDC_ComboTerms, lRes
      ComboBox Insert hDlg, %IDC_ComboTerms, 1, SearchTerm

      'highlight next/previous searchterm
      Control Send hDlg, %IDC_RichEdit, %EM_EXGetSel, 0, VarPtr(ft.chrg)
      ft.lpstrText = StrPtr(SearchTerm)
      If SearchUp Then
          ft.chrg.cpmin = ft.chrg.cpmin-1
          ft.chrg.cpmax = 0
          Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Up + %FR_MatchCase*MatchCase, VarPtr(ft) To lRes
      Else
          ft.chrg.cpmin = ft.chrg.cpmax+1
          ft.chrg.cpmax = -1
          Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down + %FR_MatchCase*MatchCase, VarPtr(ft) To lRes
      End If

      If lRes > -1 Then
          Control Send hDlg, %IDC_RichEdit, %EM_EXSetSel, 0, VarPtr(ft.chrgText)
          Control Send hDlg, %IDC_RichEdit, %EM_ScrollCaret, 0, 0
          Exit Function
      Else
          If SearchAll = 0 Then Beep : SetBeepMsg "No match found to " + IIf$(SearchUp,"start","end") + " of document!" : Exit Function
      End If

      'go to next/previous email, if appropriate
      ListView Get Select hDlg, %IDC_ListVIew To iSelect
      ListView Get Count hDlg, %IDC_ListVIew To iCount
      If SearchUp = 1 And iSelect = 1      Then Beep : SetBeepMsg "No previous message found that contains seasrch term!" : Exit Function
      If SearchUp = 0 And iSelect = iCount Then Beep : SetBeepMsg "No next message found that contains search term!" : Exit Function
      If SearchUp Then
          ListView Select hDlg, %IDC_ListView, iSelect - 1
          Control Send hDlg, %IDC_ListView, %LVM_EnsureVisible, iSelect-2, %True   'iSelect-1-1
          SetREText iSelect-1
          Control Send hDlg, %IDC_RichEdit, %EM_SetSel, 999999,999999
          Function = 1
      Else
          ListView Select hDlg, %IDC_ListView, iSelect + 1
          Control Send hDlg, %IDC_ListView, %LVM_EnsureVisible, iSelect, %True     'iSlect+1-1
          SetREText iSelect+1
          Function = 1
      End If
End Function

Sub LoadListView
    Local i,iCount As Long
    ListView Reset hDlg, %IDC_ListView
    ComboBox Get Text hDlg, %IDC_ComboFolders To CurrentFolder
    For i = 1 To UBound(EmailHeader)
        If (CurrentFolder = "All Email Folders") Or (Trim$(EmailHeader(i).Folder) = CurrentFolder) Then
            Incr iCount
            ListView Insert Item hDlg, %IDC_ListView, iCount, 0, Trim$(EmailHeader(i).Folder)
            ListView Set Text hDlg, %IDC_ListView, iCount, 2, Trim$(EmailHeader(i).From)
            ListView Set Text hDlg, %IDC_ListView, iCount, 3, Trim$(EmailHeader(i).To)
            ListView Set Text hDlg, %IDC_ListView, iCount, 4, Trim$(EmailHeader(i).date)
            ListView Set Text hDlg, %IDC_ListView, iCount, 5, Trim$(EmailHeader(i).subject)
            ListView Set Text hDlg, %IDC_ListView, iCount, 6, Trim$(Str$(i))       '<--- array position for later use
        End If
    Next i
End Sub

Function RichEditHyperLink(ByVal hWnd As Dword, ByVal lpLink As Dword) As Long
    Local enlinkPtr As ENLINK Ptr, tr As TEXTRANGE, linkText As String
    enlinkPtr    = lpLink
    tr.chrg      = @enLinkPtr.chrg
    linkText     = Space$(tr.chrg.cpMax - tr.chrg.cpMin + 2)
    tr.lpstrText = StrPtr(linkText)
    Control Send hWnd, %IDC_RichEdit, %EM_GetTextRange, 0, VarPtr(tr)
    Select Case @enLinkPtr.Msg
        Case %WM_LButtonUp
            ShellExecute(%NULL, "open", ByCopy linkText, "", "", %SW_Show)
            Function = %True                    ' Signal that we processed this
        Case %WM_MouseMove
    End Select
End Function

Sub SetBeepMsg(temp$)
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, temp$
End Sub

Sub SubClassControls
   Local ComboInfo As ComboBoxInfo
   OldTBProc = SetWindowLong(hRichEdit, %GWL_WndProc, CodePtr(NewTBProc))  'subclass
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)
   GetComboBoxInfo(GetDlgItem(hDlg,%IDC_ComboTerms), ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldCBProc = SetWindowLong(hComboEdit, %GWL_WndProc, CodePtr(NewCBProc))   'subclass a control
End Sub

Sub SelectAppFont
   Local Flags As Long, fName$, fSize,fStyle As Long
   Flags = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoSimulations Or %CF_NoScriptSel
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontStyle, Flags To fName$, fSize, fStyle
   If Len(fName$) Then FontName = fName$ : FontSize = fSize : FontStyle = fStyle : CreateAppFont
End Sub

Sub CreateAppFont
'   Control Set Font hDlg, %IDC_RichEdit, 0
'   Font End hFontRE
   Font New FontName, FontSize, FontStyle To hFontRE
   Control Set Font hDlg, %IDC_RichEdit, hFontRE
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As AsciiZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function SetColor(REFG As Long, REBG As Long) As Long  'set format of selected text
   Local cf As CHARFORMAT2
   cf.cbSize      = Len(cf)                   'Length of structure
   cf.dwMask      = %CFM_BackColor + %CFM_COLOR + %CFM_Bold    'Set mask to colors only
   cf.dwEffects   = %CFE_Bold                 'bold
   cf.crTextColor = REFG
   cf.crBackColor = REBG
   SendMessage(hRichEdit, %EM_SETCHARFORMAT, %SCF_SELECTION, VarPtr(cf))
End Function

Sub ApplySyntaxHighlighting
    'colors quotes and code
      Local StartPos,lRes,iCount,iSelect As Long, ft As FINDTEXTEX, sTermA$, sTermB$, temp$
      'QUOTES
      sTermA$ = "[QUOTE]"  :   sTermB$ = "[/QUOTE]"
      ft.chrg.cpmin = 0 : ft.chrg.cpmax = -1 : ft.lpstrText = StrPtr(sTermA$)
      Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down, VarPtr(ft) To lRes
      While lRes > -1
          SendMessage hRichEdit, %EM_EXSETSEL, 0, VarPtr(ft.chrgText)
          temp$ = String$(10,"-") + "quote: " + String$(10,"-") + $CrLf
          SendMessage hRichEdit, %EM_ReplaceSel, %True, StrPtr(temp$)
          StartPos = ft.chrgText.cpmin

          ft.chrg.cpmin = ft.chrgText.cpmax  : ft.chrg.cpmax = -1  : ft.lpstrText = StrPtr(sTermB$)
          Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down, VarPtr(ft) To lRes
          SendMessage hRichEdit, %EM_EXSETSEL, 0, VarPtr(ft.chrgText)
          temp$ = $CrLf + String$(27,"-") + $CrLf
          SendMessage hRichEdit, %EM_ReplaceSel, %True, StrPtr(temp$)

          'now select and highlight
          SendMessage hRichEdit, %EM_SETSEL, StartPos,ft.chrgText.cpmax + 20            '0, VarPtr(ft.chrgText)
          SetColor QuoteColor, %White
          ft.chrg.cpmin = ft.chrgText.cpmax : ft.chrg.cpmax = -1
          ft.lpstrText = StrPtr(sTermA$)
          Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down, VarPtr(ft) To lRes
      Wend

      'CODE
      sTermA$ = "[code]"    :   sTermB$ = "[/code]"
      ft.chrg.cpmin = 0 : ft.chrg.cpmax = -1 : ft.lpstrText = StrPtr(sTermA$)
      Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down, VarPtr(ft) To lRes
      While lRes > -1
          SendMessage hRichEdit, %EM_EXSETSEL, 0, VarPtr(ft.chrgText)
          temp$ = String$(10,"-") + "code: " + String$(10,"-") + $CrLf
          SendMessage hRichEdit, %EM_ReplaceSel, %True, StrPtr(temp$)
          StartPos = ft.chrgText.cpmin

          ft.chrg.cpmin = ft.chrgText.cpmax  : ft.chrg.cpmax = -1  : ft.lpstrText = StrPtr(sTermB$)
          Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down, VarPtr(ft) To lRes
          SendMessage hRichEdit, %EM_EXSETSEL, 0, VarPtr(ft.chrgText)
          temp$ = $CrLf + String$(26,"-") + $CrLf
          SendMessage hRichEdit, %EM_ReplaceSel, %True, StrPtr(temp$)

          SendMessage hRichEdit, %EM_SETSEL, StartPos,ft.chrgText.cpmax+19
          SetColor CodeColor, %White
          ft.chrg.cpmin = ft.chrgText.cpmax : ft.chrg.cpmax = -1
          ft.lpstrText = StrPtr(sTermA$)
          Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down, VarPtr(ft) To lRes
      Wend


End Sub

'   Local i,iTopLine,iCharPos,iResult As Long, ft As FindTextEx, temp$
'   Local Oldpd As CharRange, iEventMask&
'   iEventMask& = SendMessage(hRichEdit, %EM_GETEVENTMASK, 0, 0)   'save event mask
'   SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, 0)                 'disable event mask
'   SendMessage(hRichEdit, %WM_SETREDRAW, 0, 0)                    'disable redraw


   'restore position/eventmask, enable eventmask/redraw
'   SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(Oldpd))           'restore caret position
'   SendMessage hRichEdit, %WM_SETREDRAW, 1, 0                       'turn on redraw
'   InvalidateRect hRichEdit, ByVal %NULL, 0 : UpdateWindow hRichEdit  'refresh
'   SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, iEventMask&)              'enable event mask

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function
